import { curry, isArrayLike, forEach, equals } from 'ramda'
import applyBaobabJsPatch from './applyBaobabJsPatch'
import isPatch from './isPatch'

const applyPatch = curry((tree, patch) => {
  let patches = isArrayLike(patch) ? patch : [patch]
  forEach(x => {
    if (isPatch(x) !== true) {
      console.error(`[patch error]: op: ${x.op}, path: ${x.path}, value: ${x.value}`)
      throw isPatch(x) + JSON.stringify(x)
    }
  }, patches)

  if (equals(tree.toString(), '[object Baobab]')) {
    applyBaobabJsPatch(tree, patches)
  } else {
    throw new Error('Tree not supported to apply patch to.')
  }
})

export default applyPatch
